/* ǡڤġ
 * 05/29 2000
 * shige
 * aucut.c
 *
 * $Id: aucut.c,v 1.3 2000-11-03 18:55:47+09 shige Exp $
 */
#ifndef __AUCUT_C__
#define __AUCUT_C__

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#include "aucut.h"

int main(int argc,char *argv[])
{
    FILE *infile,*outfile=NULL;
    Snddata data;
    int j,max,sounds,n;
    Aupos h[MaxAufiles];
    double R,T,NT;
    char *path,*aufnames[MaxAufiles];

    if((n=getarg(argc,argv,&R,&T,&NT,&path,aufnames,&infile))<=0){
	usage(); 
	return Exit_getarg;
    }
    if((j=getSndheader(infile,&data)<0)){
	if(verbose) fprintf(stderr,"Error in getSndheader(). (%d)\n",j);
	return Exit_getSndheader;
    }
    if((max=getmaxdata(&data,infile))<=0){
	if(verbose) fprintf(stderr,"This has no sound data.\n");
	return Exit_getmaxdata;
    }
    else if(max>=Maxlevel){
	if(verbose) fprintf(stderr,"This has Maxlevel sound data.\n");
#ifdef MaxLevelStop
	return Exit_Maxlevel;
#endif
    };
    if((sounds=getposdata(&data,infile,max,R,T,NT,h))<0){
	if(verbose) fprintf(stderr,"Error in getposdata(). (%d\n",sounds);
	return Exit_getposdata;
    }
    if(sounds!=n){
	if(verbose) fprintf(stderr,"%d sounds found:\n",sounds);
	return Exit_n_neq_sounds;
    }
#if 0
    if(sounds>0){
#if 0
	printf("Sounds: [pos][len][lastpos]\n");
	for(j=1;j<=sounds;j++)
	  printf("%d: [%lu][%lu][%lu]\n",j,h[j-1].pos-32,h[j-1].len,
		 h[j-1].pos+h[j-1].len-32-1);
#else
	/* gnuplot  xtics ˹碌 */
	printf("set xtics (");
	for(j=1;j<=sounds;j++)
	  printf("%lu,%lu,",h[j-1].pos-32,h[j-1].pos-32+h[j-1].len-1);
	printf(")\n");
#endif
    }
#endif
    for(j=1;j<=sounds;j++){
#ifdef DEBUG1
	fprintf(stderr,"Pass 0.\n");
#endif
	if(openpathfile(&outfile,aufnames[j-1],path)<0)
	  return Exit_openpathfile;
	soundfcut(infile,outfile,&h[j-1],&data);
	fclose(outfile);
    }
    fclose(infile);
    return No_err;
}

#if 0
int main(int argc,char *argv[])
{
    FILE *file;
    Snddata data;
    int j,max,sounds,n;
    Aupos h[MaxAufiles];
    double R,T,NT;

    if(argc<1+5){
	usage();
	return 1;
    }
    if((file=fopen(argv[1],"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",argv[1]);
	return 1;
    }
    if((n=atoi(argv[2]))<=0){
	fprintf(stderr,"Set N to positive integer.\n");
	return 1;
    }
    if((R=atof(argv[3]))<=0.0){
	fprintf(stderr,"Set R to positive real number.\n");
	return 1;
    }
    if((T=atof(argv[4]))<=0.0){
	fprintf(stderr,"Set T to positive real number.\n");
	return 1;
    }
    if((NT=atof(argv[5]))<0.0){
	fprintf(stderr,"Set NT to non-negative real number.\n");
	return 1;
    }

    if((j=getSndheader(file,&data)<0)){
	fprintf(stderr,"Error in getSndheader(). (%d)\n",j);
	return 1;
    }
    /* putlineardata(&data,file); */
    if((max=getmaxdata(&data,file))<=0){
	fprintf(stderr,"This has no sound data.\n");
	return 1;
    }
    else if(max>=Maxlevel){
	fprintf(stderr,"This has Maxlevel sound data.\n");
	/* return 1; */
    };
    if((sounds=getposdata(&data,file,max,R,T,NT,h))<0){
	fprintf(stderr,"Error in getposdata(). (%d\n",sounds);
	return 1;
    }
    if(sounds!=n) fprintf(stderr,"%d sounds found:\n",sounds);
    if(sounds>0){
#if 0
	printf("Sounds: [pos][len][lastpos]\n");
	for(j=1;j<=sounds;j++)
	  printf("%d: [%lu][%lu][%lu]\n",j,h[j-1].pos-32,h[j-1].len,
		 h[j-1].pos+h[j-1].len-32-1);
#else
	/* gnuplot  xtics ˹碌 */
	printf("set xtics (");
	for(j=1;j<=sounds;j++)
	  printf("%lu,%lu,",h[j-1].pos-32,h[j-1].pos+h[j-1].len-32-1);
	printf(")\n");
#endif
    }
    return 0;
}
#endif

#if 0
int main(int argc,char *argv[])
{
    FILE *file;
    Snddata data;
    int j;

    if(argc<1 || (file=fopen(argv[1],"r"))==NULL){
	fprintf(stderr,"Usage: testlinear [au file]\n");
	return 1;
    }
    if((j=getSndheader(file,&data)<0)){
	fprintf(stderr,"Error in getSndheader(). (%d)\n",j);
	return 1;
    }
    putlineardata(&data,file);
    return 0;
}
#endif

#if 0
int main(void)
{
    int j,k;
    
    for(j=0;j<=255;j++){
	k=u2l(j);
	printf("%d 0x%04x %u\n",j,(unsigned short int)k,(unsigned short int)k);
    }
    return 0;
}
#endif

/* ##########  ########## */
void soundfcut(FILE *infile,FILE *outfile,Aupos *pos,Snddata *InSnd)
{
    int len;
#if 0
    Snddata snd;

    getSndheader(infile,&snd);
    /* Ϥ餦Ȥˤ */
#endif
#ifdef DEBUG3
    fprintf(stderr,"(pos,len)=(%d,%d)\n",pos->pos,pos->len);
#endif
    len=InSnd->datalen;
    InSnd->datalen=pos->len;
    putallheader(outfile,InSnd,1);
    putfile2file(infile,outfile,pos->pos,pos->len);
    InSnd->datalen=len;
}

/* for DEBUG */
int putlineardata(Snddata *Snd,FILE *file)
{
    int j,k=0;
    short int x;
    
    fseek(file,Snd->hlen,SEEK_SET);
    for(j=1;j<=Snd->datalen;j++){
#if 0
	x=u2l(fgetc(file));
#else
	x=ulaw2linear(fgetc(file));
#endif
	printf("%d %d\n",k++,x);
    }
    return No_err;
}

int openpathfile(FILE **Outfile,char *fname,char *path)
{
    char buff[MaxPathBuff];
    
#ifdef DEBUG1
    fprintf(stderr,"Pass 0.5.\n");
    fprintf(stderr,"path=[%s]\n",path);
    fprintf(stderr,"fname=[%s]\n",fname);
#endif
    if(strlen(path)+1+strlen(fname)+1>MaxPathBuff)
      return Err_longpath;
    strcpy(buff,path);
    strcat(buff,PathDelimiter);
    strcat(buff,fname);
    strcat(buff,AuFileExt);
#ifdef USEFREOPEN
    if(*Outfile==NULL){
	if((*Outfile=fopen(buff,"w"))==NULL) return Err_fopen;
    }
    else if((*Outfile=freopen(buff,"w",*Outfile))==NULL) return Err_fopen;
#else
    if(*Outfile!=NULL) fclose(*Outfile);
    if((*Outfile=fopen(buff,"w"))==NULL) return Err_fopen;
#endif
    return No_err;
}

/* ##########  ########## */
#if 0
short int u2l(unsigned char c)
{
    int t;

    c=~c;
    t=((c&0xf)<<3)+0x84;
    t<<=((unsigned)c & 0x70)>>4;
    return (c&0x80)?(0x84-t):(t-0x84);
}
#endif

/* 1 path 
 * ͤκ֤ͤ
 */
int getmaxdata(Snddata *Snd,FILE *file)
{
    int j,k=0,max=0,x;
    
    fseek(file,Snd->hlen,SEEK_SET);
    for(j=1;j<=Snd->datalen;j++){
	x=ulaw2linear(fgetc(file));
	if(x<0) x=-x;
	if(x>max) max=x;
    }
    return max;
}

/* 2 path 
 * S/N Τ R ̵ʬκû NT Ȥäƻΰ֤
 * n:  data θĿ
 * T: û data
 */
int getposdata(Snddata *Snd,FILE *file,int max,double R,double T,
	       double NT,Aupos h[])
{
    int j;
    int noise,innoise,soundnum,noiselen,soundlen,pos;
    int Minnoiselen,Minsoundlen;
    double maxR;
    short int x;

    if(max<=0 || R<=0.0 || NT<=0.0 || T<0.0) return Err_param;
    Minnoiselen=(int)(NT*SAMPLES)+1;
    Minsoundlen=(int)(T*SAMPLES)+1;
    fseek(file,Snd->hlen,SEEK_SET);

    x=ulaw2linear(fgetc(file));
    maxR=max*R;
    if(x<=maxR && x>=-maxR){ /* Υ */
	innoise=1;
	noiselen=1;
	soundnum=0;
    }
    else{
	soundnum=1;
#ifdef DEBUG2
	fprintf(stderr,"%d sound start\n",soundnum);
#endif
	pos=ftell(file);
	soundlen=1;
	innoise=0;
    }
#ifdef DEBUG2
    fprintf(stderr,"(Minnoiselen,Minsoundlen)=(%d,%d)\n",
	    Minnoiselen,Minsoundlen);
    fprintf(stderr,"max=%d,x=%d,innoise=%d\n",max,x,innoise);
    fprintf(stderr,"NR:(x,x/max,noise,innoise):\n");
#endif
    
    for(j=2;j<=Snd->datalen;j++){
	x=ulaw2linear(fgetc(file));
#ifdef DEBUG2
	fprintf(stderr,"%d:(%d,%f,%d,%d)\n",j,x,(double)x/(double)max,
		(x<=maxR && x>=-maxR)?1:0,innoise);
#endif
	if(x<=maxR && x>=-maxR){ /* Υ */
	    switch(innoise){
	    case 2: /* ʥΥ */
		break;
	    case 1: /* ΰΤʤ */
		if(++noiselen>Minnoiselen){
		    if(soundnum>0){
			if(soundlen>=Minsoundlen){
#ifdef DEBUG2
			    fprintf(stderr,"%d sound end\n",soundnum);
#endif
			    h[soundnum-1].pos=pos;
			    h[soundnum-1].len=soundlen;
			}
			else{
#ifdef DEBUG2
			    fprintf(stderr,"Not a %d sound\n",soundnum);
#endif
			    soundnum--;
			}
		    }
		    innoise=2;
		}
		break;
	    case 0: /*  */
		innoise=1;
		noiselen=1;
		break;
	    }
	}
	else{
	    switch(innoise){
	    case 2: 
		if(++soundnum>MaxAufiles)
		  return Err_too_many_sounds;
#ifdef DEBUG2
		fprintf(stderr,"%d sound start\n",soundnum);
#endif
		soundlen=1;
		pos=ftell(file);
		innoise=0;
		break;
	    case 1: 
		if(soundnum>0)
		  soundlen+=noiselen+1;
		innoise=0;
		break;
	    case 0:
		soundlen++;
		break;
	    }
	}
    }

    switch(innoise){
    case 1: 
	if(soundnum>0){
	    soundlen+=noiselen;
	    if(soundlen>=Minsoundlen){
#ifdef DEBUG2
		fprintf(stderr,"%d sound end\n",soundnum);
#endif
		h[soundnum-1].pos=pos;
		h[soundnum-1].len=soundlen;
	    }
	    else
	      soundnum--;
	}
	break;
    case 0:
	if(soundnum>0){
	    if(soundlen>=Minsoundlen){
#ifdef DEBUG2
		fprintf(stderr,"%d sound end\n",soundnum);
#endif
		h[soundnum-1].pos=pos;
		h[soundnum-1].len=soundlen;
	    }
	    else
	      soundnum--;
	}
	break;
    }
    return soundnum;
}

/* ########## option parameter  ########## */
int getarg(int argc,char *argv[],double *R,double *T,double *NT,char **Path,
	   char *aufnames[],FILE **Infile)
{
    int j,ret;
    char c;
    double x;

    *R=Default_R;
    *T=Default_T;
    *NT=Default_NT;
    *Path=Default_Path;
    
    if(argc<NeedOptions+1) return Err_argnum;
    j=1;
    while(*argv[j]=='-'){
	if((c=*(++argv[j]))=='r' || c=='t' || c=='s'){
	    if(*(++argv[j])=='\0' && ++j>=argc-NeedOptions) return Err_param;
	    if((x=atof(argv[j]))<=0.0) return Err_bad_value;
	    switch(c){
	    case 'r': *R=x; break;
	    case 't': *T=x; break;
	    case 's': *NT=x; break;
	    }
	}
	else if(c=='p'){
	    if(*(++argv[j])=='\0' && ++j>=argc-NeedOptions) return Err_param;
	    *Path=argv[j];
	}
	else if(c=='v'){
	    if(*(++argv[j])!='\0') return Err_param;
	    verbose=1;
	}
	else return Err_unknown_option;
	++j;
    }
    if(j!=argc-NeedOptions) return Err_argnum;
    if((ret=op2aufnames(aufnames,MaxAufiles,argv[j++]))<0) return ret;
    if((*Infile=fopen(argv[j],"r"))==NULL) return Err_fopen;
    return ret;
}

/* 겻ե̾ fnames[]  ( max ) ¸  */
int op2aufnames(char *fnames[],int max,char *option)
{
    int flag=0,len=0,num=0,j;
    char *ss,sh0[MaxNameLen],sf0[MaxNameLen];
    int start,end;

    ss=sh0;
    while(1){
	switch(*option){
	case '-':
	    *ss='\0';
	    ss=sf0;
	    len=0;
	    flag=1;
	    break;
	case ',':
	case '\0':
	    *ss='\0';
	    if(flag){ /* [a]-[b] */
		if((start=searchautable(sh0))<0 || (end=searchautable(sf0))<0
		    || start>end) return Err_bad_value;
		if(num+end-start+1>max) return Err_too_many_sounds;
		for(j=start;j<=end;j++)
		  fnames[++num-1]=aufiletable[j];
		flag=0;
	    }
	    else{ /* [a] */
		if((start=searchautable(sh0))<0) return Err_bad_value;
		if(num+1>max) return Err_too_many_sounds;
		fnames[++num-1]=aufiletable[start];
	    }
	    if(*option == '\0') return num;
	    len=0;
	    ss=sh0;
	    break;
	default:
	    if(++len>=MaxNameLen) return Err_bad_value;
	    *(ss++)=*option;
	    break;
	}
	option++;
    }
}

/* aufiletable[] 鳺򸡺 (0~) */
int searchautable(char *s)
{
    int j;

    if(strlen(s)<=0) return Err_bad_value;
    for(j=0;strcmp(aufiletable[j],AUFTABLELAST)!=0;j++)
      if(strcmp(s,aufiletable[j])==0) return j;
    return Err_bad_value;
}

void usage(void)
{
    char *mess[]={
	"Usage: aucut [options] [ϥե] [aufile]",
	" options:",
#if 0
	"   -r[R] : S/N Τ (default=" Default_R ")",
	"   -t[T] : ûǡĹ [] (default=" Default_T ")",
	"   -s[S] : ûʬĹ [] (default=" Default_NT ")",
	"   -p[path]: ϥեǼѥ (default=" Default_Path ")",
#else
	"   -r[R] : S/N Τ (default=0.1)",
	"   -t[T] : ûǡĹ [] (default=0.01)",
	"   -s[S] : ûʬĹ [] (default=0.01)",
	"   -p[path]: ϥեǼѥ (default=ȥǥ쥯ȥ)",
#endif
	"   -v    : Ĺ",
	" ",
	" [1] ϥե",
	"     (a)  ',' ڤ (: a,o,ko)",
	"     (b)  '-' ڤ (: a-ko ==> a,i,u,e,o,ka,ki,ku,ke,ko)",
	"     νǤ롣ڡʤȡ",
	" [2] (ζκ)(S/N Τ) ʲζΥǡ",
	"     ʬϻʬȤߤʤ롣ä",
	"      ==> 򽦤䤹ʤꡢƲĹˤʤꡢ",
	"                    ",
	"     礭 ==> ȸʤƼΤƤƤޤ",
	"                    Ʋûˤʤꡢϸ",
	" [3] ûǡĹûʬϻȸʤä",
	"      ==> ԡΥΥ򽦤䤹ʤ",
	"     礭 ==> ûΥȸƼΤƤƤޤ",
	" [4] ǡλʬǡûʬĹûʬϰŪ",
	"     ǡ夯ʤäƤʬȽǤǡ³Ƥ",
	"     ʤ",
	"      ==> Ū˼夤ʬⲻڤܤȽǤƲ",
	"                    ڤäƤޤ",
	"     礭 ==> ȲȤδ֤ⲻĤʤäƤȸʤƲ",
	"                    ڤʤʤ",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}

#endif /* __AUCUT_C__ */
