/* WAV file ôʬ
 * shige
 * 10/01 2000
 * wavio.c
 *
 * $Id: wavio.c,v 1.5 2001-02-28 18:04:57+09 shige Exp $
 */
#ifndef __WAVIO_C__
#define __WAVIO_C__

#include "wavio.h"

/* #define DEBUG1 */
/* #define DEBUG2 */

/* wav file  header μ */
int getWAVheader(FILE *file,WAVdata *wd)
{
    long int j;
    long int fsize,csize;

    fseek(file,0,SEEK_SET);
    if(read4bytetolittlei(file,&j)<0 || j != sto4bytelittlei("RIFF"))
      return Err_readwavheader;
    if(read4bytetolittlei(file,&fsize)<0) return Err_readwavheader;
    fsize+=8;
    if(read4bytetolittlei(file,&j)<0 || j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    /* chunk θ */
    while(1){
	if(ftell(file)>fsize-8) break;
	if(read4bytetolittlei(file,&j)<0 || read4bytetolittlei(file,&csize)<0)
	  return Err_readwavheader;
	if(j == sto4bytelittlei("fmt ")){
	    if(csize<14
	       || read2bytetolittlei(file,&(wd->fmcode))<0
	       || read2bytetolittlei(file,&(wd->channel))<0
	       || read4bytetolittlei(file,&(wd->smplrate))<0
	       || read4bytetolittlei(file,&(wd->bytepersec))<0
	       || read2bytetolittlei(file,&(wd->blocksize))<0)
	      return Err_readwavheader;
	    if(csize==14){
		if(wd->channel<=0) return Err_readwavheader;
		wd->bitpersmpl=wd->blocksize*8/wd->channel;
	    }
	    if(csize>=16){
		if(read2bytetolittlei(file,&(wd->bitpersmpl))<0)
		  return Err_readwavheader;
		if(csize>16) fseek(file,csize-16,SEEK_CUR);
	    }
	    else return Err_readwavheader;
	}
	else{
	    if(j == sto4bytelittlei("data")){
		wd->datalen=csize;
		wd->hlen=ftell(file);
	    }
	    fseek(file,csize,SEEK_CUR);
	}
	if(csize%2) fseek(file,1,SEEK_CUR);
    }
    return No_err;
}

/* wav file  header μ & chunk list κ */
int getWAVinfo(FILE *file,WAVdata *wd,Chunk *Ch)
{
    long int j;
    long int fsize;
    Chunk *ch;
    int chunks=0;

    fseek(file,0,SEEK_SET);
    if(read4bytetolittlei(file,&j)<0 || j != sto4bytelittlei("RIFF"))
      return Err_readwavheader;
    if(read4bytetolittlei(file,&fsize)<0) return Err_readwavheader;
    fsize+=8;
    if(read4bytetolittlei(file,&j)<0 || j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    /* chunk θ */
    while(1){
	if(ftell(file)>fsize-8) break;
	if(++chunks>Maxchunks) return Err_too_many_chunks;
	ch=&(Ch[chunks-1]);
	ch->start=ftell(file);
	if(fread(ch->id,4,1,file)<1) return Err_readwavheader;
	if(read4bytetolittlei(file,&(ch->size))<0) return Err_readwavheader;
	if(strncmp(ch->id,"fmt ",4)==0){ /* format chunk */
	    if(ch->size<14
	       || read2bytetolittlei(file,&(wd->fmcode))<0
	       || read2bytetolittlei(file,&(wd->channel))<0
	       || read4bytetolittlei(file,&(wd->smplrate))<0
	       || read4bytetolittlei(file,&(wd->bytepersec))<0
	       || read2bytetolittlei(file,&(wd->blocksize))<0)
	      return Err_readwavheader;
	    if(ch->size==14){ /* bitpersmpl ʤΤ support */
		if(wd->channel<=0) return Err_readwavheader;
		wd->bitpersmpl=wd->blocksize*8/wd->channel;
	    }
	    if(ch->size>=16){
		if(read2bytetolittlei(file,&(wd->bitpersmpl))<0)
		  return Err_readwavheader;
		if(ch->size>16) fseek(file,ch->size-16,SEEK_CUR);
	    }
	    else return Err_readwavheader;
	}
	else{
	    if(strncmp(ch->id,"data",4)==0){ /* data chunk */
		wd->datalen=ch->size;
		wd->hlen=ftell(file);
	    }
	    fseek(file,ch->size,SEEK_CUR);
	}
	if((ch->size)%2) fseek(file,1,SEEK_CUR); /* word alignment */
    }
    return chunks;
}

/* WAV header  */
int chWAVheader(WAVdata *wd1,WAVdata *wd2)
{
    if(wd1->fmcode != wd2->fmcode) return Err_diffmcode;
    if(wd1->channel != wd2->channel) return Err_diffchannel;
    if(wd1->smplrate != wd2->smplrate) return Err_diffsmplrate;
    if(wd1->bytepersec != wd2->bytepersec) return Err_diffbytepersec;
    if(wd1->blocksize != wd2->blocksize) return Err_diffblocksize;
    if(wd1->bitpersmpl != wd2->bitpersmpl) return Err_diffbitpersmpl;
    return No_err;
}

/* WAV wd[] Ĥʤ file  header ν */
void putallWAVheader(FILE *file,WAVdata *wd,int N)
{
    int j;
    int datalen=0;

    writelittleito4byte(file,sto4bytelittlei("RIFF"));
    /* fputs("RIFF",file); */
    for(j=1;j<=N;j++) datalen+=wd[j-1].datalen;    
    writelittleito4byte(file,4+4+4+16+4+4+datalen+datalen%2);
    writelittleito4byte(file,sto4bytelittlei("WAVE"));
    writelittleito4byte(file,sto4bytelittlei("fmt "));
    writelittleito4byte(file,16);
    writelittleito2byte(file,wd[0].fmcode);
    writelittleito2byte(file,wd[0].channel);
    writelittleito4byte(file,wd[0].smplrate);
    writelittleito4byte(file,wd[0].bytepersec);
    writelittleito2byte(file,wd[0].blocksize);
    writelittleito2byte(file,wd[0].bitpersmpl);
    writelittleito4byte(file,sto4bytelittlei("data"));
    writelittleito4byte(file,datalen);
}

/* Ĺ */
void putallWAVheader2(FILE *file,WAVdata *wd,int N,int len,int addsp)
{
    int j;
    int datalen=0;

    writelittleito4byte(file,sto4bytelittlei("RIFF"));
    /* fputs("RIFF",file); */
    len*=wd[0].blocksize;
    for(j=1;j<=N;j++)
      datalen+=(len>0 && (wd[j-1].datalen>=len ||addsp))?len:wd[j-1].datalen;
    writelittleito4byte(file,4+4+4+16+4+4+datalen+datalen%2);
    writelittleito4byte(file,sto4bytelittlei("WAVE"));
    writelittleito4byte(file,sto4bytelittlei("fmt "));
    writelittleito4byte(file,16);
    writelittleito2byte(file,wd[0].fmcode);
    writelittleito2byte(file,wd[0].channel);
    writelittleito4byte(file,wd[0].smplrate);
    writelittleito4byte(file,wd[0].bytepersec);
    writelittleito2byte(file,wd[0].blocksize);
    writelittleito2byte(file,wd[0].bitpersmpl);
    writelittleito4byte(file,sto4bytelittlei("data"));
    writelittleito4byte(file,datalen);
}

#endif /* __WAVIO_C__ */
